Index: trunk/examples/advanced/hadrontherapy/src/HadrontherapyDetectorMessenger.cc
===================================================================
--- trunk/examples/advanced/hadrontherapy/src/HadrontherapyDetectorMessenger.cc	(revision 812)
+++ trunk/examples/advanced/hadrontherapy/src/HadrontherapyDetectorMessenger.cc	(revision 1230)
@@ -24,18 +24,8 @@
 // ********************************************************************
 //
-// $Id: HadrontherapyDetectorMessenger.cc; May 2005
-// ----------------------------------------------------------------------------
-//                 GEANT 4 - Hadrontherapy example
-// ----------------------------------------------------------------------------
-// Code developed by:
-//
-// G.A.P. Cirrone(a)*, F. Di Rosa(a), S. Guatelli(b), G. Russo(a)
-// 
-// (a) Laboratori Nazionali del Sud 
-//     of the INFN, Catania, Italy
-// (b) INFN Section of Genova, Genova, Italy
-// 
-// * cirrone@lns.infn.it
-// ----------------------------------------------------------------------------
+// $Id: HadrontherapyDetectorMessenger.cc; 
+// See more at: http://g4advancedexamples.lngs.infn.it/Examples/hadrontherapy
+
+
 #include "HadrontherapyDetectorMessenger.hh"
 #include "HadrontherapyDetectorConstruction.hh"
@@ -43,136 +33,109 @@
 #include "G4UIcmdWithADoubleAndUnit.hh"
 #include "G4UIcmdWithAString.hh"
+#include "G4UIcmdWith3VectorAndUnit.hh"
 
-HadrontherapyDetectorMessenger::HadrontherapyDetectorMessenger(
-							       HadrontherapyDetectorConstruction* detector)
+/////////////////////////////////////////////////////////////////////////////
+HadrontherapyDetectorMessenger::HadrontherapyDetectorMessenger(HadrontherapyDetectorConstruction* detector)
   :hadrontherapyDetector(detector)
-{ 
-  modulatorDir = new G4UIdirectory("/modulator/");
-  modulatorDir -> SetGuidance("Command to rotate the modulator wheel");
-  
-  beamLineDir = new G4UIdirectory("/beamLine/");
-  beamLineDir -> SetGuidance("set specification of range shifter");  
+{
+    // Change Phantom size
+    changeThePhantomDir = new G4UIdirectory("/changePhantom/");
+    changeThePhantomDir -> SetGuidance("Command to change the Phantom Size/position");
+    changeThePhantomSizeCmd = new G4UIcmdWith3VectorAndUnit("/changePhantom/size", this);
+    changeThePhantomSizeCmd -> SetGuidance("Insert sizes X Y and Z"
+	                                   "\n   0 or negative values mean <<Don't change it!>>");
+    changeThePhantomSizeCmd -> SetParameterName("PhantomSizeAlongX", 
+						"PhantomSizeAlongY", 
+						"PhantomSizeAlongZ", false);
+    changeThePhantomSizeCmd -> SetDefaultUnit("mm");
+    changeThePhantomSizeCmd -> SetUnitCandidates("um mm cm"); 
+    changeThePhantomSizeCmd -> AvailableForStates(G4State_Idle);
 
-  rangeShifterDir = new G4UIdirectory("/beamLine/RangeShifter/");
-  rangeShifterDir -> SetGuidance("set specification of range shifter");  
 
-  firstScatteringFoilDir = new G4UIdirectory("/beamLine/ScatteringFoil1/");
-  firstScatteringFoilDir -> SetGuidance("set specification of first scattering foil");  
- 
-  secondScatteringFoilDir = new G4UIdirectory("/beamLine/ScatteringFoil2/");
-  secondScatteringFoilDir -> SetGuidance("set specification of second scattering foil");  
- 
-  rangeStopperDir = new G4UIdirectory("/beamLine/Stopper/");
-  rangeStopperDir -> SetGuidance("set specification of stopper");  
+    // Change Phantom position
+    changeThePhantomPositionCmd = new G4UIcmdWith3VectorAndUnit("/changePhantom/position", this);
+    changeThePhantomPositionCmd -> SetGuidance("Insert X Y and Z dimensions for the position of the center of the Phantom"
+						" respect to that of the \"World\""); 
+    changeThePhantomPositionCmd -> SetParameterName("PositionAlongX", 
+						    "PositionAlongY", 
+						    "PositionAlongZ", false);
+    changeThePhantomPositionCmd -> SetDefaultUnit("mm");
+    changeThePhantomPositionCmd -> SetUnitCandidates("mm cm m"); 
+    changeThePhantomPositionCmd -> AvailableForStates(G4State_Idle);
 
-  finalCollimatorDir = new G4UIdirectory("/beamLine/FinalCollimator/");
-  finalCollimatorDir -> SetGuidance("set specification of final collimator");  
 
-  modulatorAngleCmd = new G4UIcmdWithADoubleAndUnit("/modulator/angle",this);
-  modulatorAngleCmd -> SetGuidance("Set Modulator Angle");
-  modulatorAngleCmd -> SetParameterName("Size",false);
-  modulatorAngleCmd -> SetRange("Size>=0.");
-  modulatorAngleCmd -> SetUnitCategory("Angle");  
-  modulatorAngleCmd -> AvailableForStates(G4State_Idle);
-  
-  rangeShifterMatCmd = new G4UIcmdWithAString("/beamLine/RangeShifter/RSMat",this);
-  rangeShifterMatCmd -> SetGuidance("Set material of range shifter");
-  rangeShifterMatCmd -> SetParameterName("choice",false);
-  rangeShifterMatCmd -> AvailableForStates(G4State_Idle);
-  
-  rangeShifterXSizeCmd = new G4UIcmdWithADoubleAndUnit("/beamLine/RangeShifter/thickness",this);
-  rangeShifterXSizeCmd -> SetGuidance("Set half of the thickness of range shifter along X axis");
-  rangeShifterXSizeCmd -> SetParameterName("Size",false);
-  rangeShifterXSizeCmd -> SetDefaultUnit("mm");  
-  rangeShifterXSizeCmd -> SetUnitCandidates("mm cm m");  
-  rangeShifterXSizeCmd -> AvailableForStates(G4State_Idle);
-  
-  rangeShifterXPositionCmd = new G4UIcmdWithADoubleAndUnit("/beamLine/RangeShifter/position",this);
-  rangeShifterXPositionCmd -> SetGuidance("Set position of range shifter");
-  rangeShifterXPositionCmd -> SetParameterName("Size",false);
-  rangeShifterXPositionCmd -> SetDefaultUnit("mm");  
-  rangeShifterXPositionCmd -> SetUnitCandidates("mm cm m");  
-  rangeShifterXPositionCmd -> AvailableForStates(G4State_Idle);
-  
-  firstScatteringFoilXSizeCmd = new G4UIcmdWithADoubleAndUnit("/beamLine/ScatteringFoil1/thickness",this);
-  firstScatteringFoilXSizeCmd -> SetGuidance("Set hlaf thickness of first scattering foil");
-  firstScatteringFoilXSizeCmd -> SetParameterName("Size",false);
-  firstScatteringFoilXSizeCmd -> SetDefaultUnit("mm");  
-  firstScatteringFoilXSizeCmd -> SetUnitCandidates("mm cm m");  
-  firstScatteringFoilXSizeCmd -> AvailableForStates(G4State_Idle);
-  
-  secondScatteringFoilXSizeCmd = new G4UIcmdWithADoubleAndUnit("/beamLine/ScatteringFoil2/thickness",this);
-  secondScatteringFoilXSizeCmd -> SetGuidance("Set half thickness of second scattering foil");
-  secondScatteringFoilXSizeCmd -> SetParameterName("Size",false);
-  secondScatteringFoilXSizeCmd -> SetDefaultUnit("mm");  
-  secondScatteringFoilXSizeCmd -> SetUnitCandidates("mm cm m");  
-  secondScatteringFoilXSizeCmd -> AvailableForStates(G4State_Idle);
-  
-  outerRadiusStopperCmd = new G4UIcmdWithADoubleAndUnit("/beamLine/Stopper/outRadius",this);
-  outerRadiusStopperCmd -> SetGuidance("Set size of outer radius");
-  outerRadiusStopperCmd -> SetParameterName("Size",false);
-  outerRadiusStopperCmd -> SetDefaultUnit("mm");  
-  outerRadiusStopperCmd -> SetUnitCandidates("mm cm m");  
-  outerRadiusStopperCmd -> AvailableForStates(G4State_Idle);
-  
-  innerRadiusFinalCollimatorCmd = new G4UIcmdWithADoubleAndUnit("/beamLine/FinalCollimator/halfInnerRad",this);
-  innerRadiusFinalCollimatorCmd -> SetGuidance("Set size of inner radius ( max 21.5 mm)");
-  innerRadiusFinalCollimatorCmd -> SetParameterName("Size",false);
-  innerRadiusFinalCollimatorCmd -> SetDefaultUnit("mm");  
-  innerRadiusFinalCollimatorCmd -> SetUnitCandidates("mm cm m");  
-  innerRadiusFinalCollimatorCmd -> AvailableForStates(G4State_Idle);
+    //  Change detector size
+    changeTheDetectorDir = new G4UIdirectory("/changeDetector/");
+    changeTheDetectorDir -> SetGuidance("Command to change the Detector's Size/position/Voxels");
+    
+    changeTheDetectorSizeCmd = new G4UIcmdWith3VectorAndUnit("/changeDetector/size",this);
+    changeTheDetectorSizeCmd -> SetGuidance("Insert sizes for X Y and Z dimensions of the Detector"
+					    "\n   0 or negative values mean <<Don't change it>>");
+    changeTheDetectorSizeCmd -> SetParameterName("DetectorSizeAlongX", "DetectorSizeAlongY", "DetectorSizeAlongZ", false);
+    changeTheDetectorSizeCmd -> SetDefaultUnit("mm");
+    changeTheDetectorSizeCmd -> SetUnitCandidates("um mm cm"); 
+    changeTheDetectorSizeCmd -> AvailableForStates(G4State_Idle);
+
+    //  Change the detector to phantom displacement
+    changeTheDetectorToPhantomPositionCmd = new G4UIcmdWith3VectorAndUnit("/changeDetector/displacement",this);
+    changeTheDetectorToPhantomPositionCmd -> SetGuidance("Insert X Y and Z displacements between Detector and Phantom"
+	                                                 "\nNegative values mean <<Don't change it!>>"); 
+    changeTheDetectorToPhantomPositionCmd -> SetParameterName("DisplacementAlongX",
+							      "DisplacementAlongY", 
+							      "DisplacementAlongZ", false);
+    changeTheDetectorToPhantomPositionCmd -> SetDefaultUnit("mm");
+    changeTheDetectorToPhantomPositionCmd -> SetUnitCandidates("um mm cm"); 
+    changeTheDetectorToPhantomPositionCmd -> AvailableForStates(G4State_Idle);
+    
+    // Change voxels by its size
+    changeTheDetectorVoxelCmd = new G4UIcmdWith3VectorAndUnit("/changeDetector/voxelSize",this);
+    changeTheDetectorVoxelCmd -> SetGuidance("Insert Voxel sizes for X Y and Z dimensions"
+		                             "\n   0 or negative values mean <<Don't change it!>>");
+    changeTheDetectorVoxelCmd -> SetParameterName("VoxelSizeAlongX", "VoxelSizeAlongY", "VoxelSizeAlongZ", false);
+    changeTheDetectorVoxelCmd -> SetDefaultUnit("mm");
+    changeTheDetectorVoxelCmd -> SetUnitCandidates("um mm cm");
+    changeTheDetectorVoxelCmd -> AvailableForStates(G4State_Idle);
+   }
+
+/////////////////////////////////////////////////////////////////////////////
+HadrontherapyDetectorMessenger::~HadrontherapyDetectorMessenger()
+{
+    delete changeThePhantomDir; 
+    delete changeThePhantomSizeCmd; 
+    delete changeThePhantomPositionCmd; 
+    delete changeTheDetectorDir; 
+    delete changeTheDetectorSizeCmd; 
+    delete changeTheDetectorToPhantomPositionCmd; 
+    delete changeTheDetectorVoxelCmd; 
 }
 
-HadrontherapyDetectorMessenger::~HadrontherapyDetectorMessenger()
-{ 
-  delete innerRadiusFinalCollimatorCmd;  
-  delete outerRadiusStopperCmd;  
-  delete secondScatteringFoilXSizeCmd; 
-  delete firstScatteringFoilXSizeCmd; 
-  delete rangeShifterXPositionCmd;
-  delete rangeShifterXSizeCmd;
-  delete rangeShifterMatCmd;
-  delete modulatorAngleCmd;
-  delete finalCollimatorDir; 
-  delete rangeStopperDir;
-  delete secondScatteringFoilDir;
-  delete firstScatteringFoilDir; 
-  delete rangeShifterDir;  
-  delete beamLineDir; 
-  delete modulatorDir;   
+/////////////////////////////////////////////////////////////////////////////
+void HadrontherapyDetectorMessenger::SetNewValue(G4UIcommand* command,G4String newValue)
+{
+	
+  if( command == changeThePhantomSizeCmd)
+    {
+	G4ThreeVector size = changeThePhantomSizeCmd -> GetNew3VectorValue(newValue);
+	hadrontherapyDetector -> SetPhantomSize(size.getX(),size.getY(),size.getZ());
+    }
+  else if (command == changeThePhantomPositionCmd )
+  {
+	 G4ThreeVector size = changeThePhantomPositionCmd -> GetNew3VectorValue(newValue);
+         hadrontherapyDetector -> SetPhantomPosition(size);
+  }
+  else if (command == changeTheDetectorSizeCmd)
+  {
+	G4ThreeVector size = changeTheDetectorSizeCmd  -> GetNew3VectorValue(newValue);
+        hadrontherapyDetector -> SetDetectorSize(size.getX(),size.getY(),size.getZ());
+  }
+  else if (command == changeTheDetectorToPhantomPositionCmd)
+  {
+	G4ThreeVector size = changeTheDetectorToPhantomPositionCmd-> GetNew3VectorValue(newValue);
+        hadrontherapyDetector -> SetDetectorToPhantomPosition(size);
+  }
+  else if (command == changeTheDetectorVoxelCmd)
+  {
+	G4ThreeVector size = changeTheDetectorVoxelCmd  -> GetNew3VectorValue(newValue);
+        hadrontherapyDetector -> SetNumberOfVoxelBySize(size.getX(),size.getY(),size.getZ());
+  }
 }
-
-void HadrontherapyDetectorMessenger::SetNewValue(G4UIcommand* command,G4String newValue)
-{ 
-  if( command == modulatorAngleCmd )
-    { hadrontherapyDetector -> SetModulatorAngle
-           (modulatorAngleCmd -> GetNewDoubleValue(newValue));}
-
-  if( command == rangeShifterMatCmd )
-    { hadrontherapyDetector -> SetRSMaterial(newValue);}
-
-  if( command == rangeShifterXSizeCmd )
-    { hadrontherapyDetector -> SetRangeShifterXSize
-            (rangeShifterXSizeCmd -> GetNewDoubleValue(newValue));}
-
-  if( command == rangeShifterXPositionCmd )
-    { hadrontherapyDetector -> SetRangeShifterXPosition
-                  (rangeShifterXPositionCmd -> GetNewDoubleValue(newValue));}
-
-  if( command == firstScatteringFoilXSizeCmd )
-    { hadrontherapyDetector -> SetFirstScatteringFoilSize
-                  (firstScatteringFoilXSizeCmd -> GetNewDoubleValue(newValue));}
-
-  if( command == secondScatteringFoilXSizeCmd )
-    { hadrontherapyDetector -> SetSecondScatteringFoilSize
-                  (secondScatteringFoilXSizeCmd -> GetNewDoubleValue(newValue));}
-
-  if( command == outerRadiusStopperCmd )
-    { hadrontherapyDetector -> SetOuterRadiusStopper(
-                    outerRadiusStopperCmd -> GetNewDoubleValue(newValue));}
-
-  if( command == innerRadiusFinalCollimatorCmd )
-    { hadrontherapyDetector -> SetInnerRadiusFinalCollimator
-                  (innerRadiusFinalCollimatorCmd -> GetNewDoubleValue(newValue));}
-}
-
Index: trunk/examples/advanced/hadrontherapy/src/HadrontherapyEventAction.cc
===================================================================
--- trunk/examples/advanced/hadrontherapy/src/HadrontherapyEventAction.cc	(revision 812)
+++ trunk/examples/advanced/hadrontherapy/src/HadrontherapyEventAction.cc	(revision 1230)
@@ -24,18 +24,7 @@
 // ********************************************************************
 //
-// $Id: HadrontherapyEventAction.cc; May 2005
-// ----------------------------------------------------------------------------
-//                 GEANT 4 - Hadrontherapy example
-// ----------------------------------------------------------------------------
-// Code developed by:
-//
-// G.A.P. Cirrone(a)*, G. Candiano, F. Di Rosa(a), S. Guatelli(b), G. Russo(a)
-// 
-// (a) Laboratori Nazionali del Sud 
-//     of the National Institute for Nuclear Physics, Catania, Italy
-// (b) National Institute for Nuclear Physics Section of Genova, genova, Italy
-// 
-// * cirrone@lns.infn.it
-// --------------------------------------------------------------
+// $Id: HadrontherapyEventAction.cc; 
+// See more at: http://g4advancedexamples.lngs.infn.it/Examples/hadrontherapy
+
 #include "G4Event.hh"
 #include "G4EventManager.hh"
@@ -48,44 +37,55 @@
 #include "G4VVisManager.hh"
 #include "HadrontherapyEventAction.hh"
-#include "HadrontherapyPhantomHit.hh"
-#include "HadrontherapyPhantomSD.hh"
+#include "HadrontherapyDetectorHit.hh"
+#include "HadrontherapyDetectorSD.hh"
 #include "HadrontherapyDetectorConstruction.hh"
 #include "HadrontherapyMatrix.hh"
+#include "HadrontherapyEventActionMessenger.hh"
 
-HadrontherapyEventAction::HadrontherapyEventAction(HadrontherapyMatrix* matrixPointer) :
-  drawFlag("all" )
+/////////////////////////////////////////////////////////////////////////////
+HadrontherapyEventAction::HadrontherapyEventAction() :
+  drawFlag("all" ),printModulo(1000), pointerEventMessenger(0)
 { 
   hitsCollectionID = -1;
-  matrix = matrixPointer; 
+  pointerEventMessenger = new HadrontherapyEventActionMessenger(this);
 }
 
+/////////////////////////////////////////////////////////////////////////////
 HadrontherapyEventAction::~HadrontherapyEventAction()
 {
+ delete pointerEventMessenger;
 }
 
-void HadrontherapyEventAction::BeginOfEventAction(const G4Event* )
-{
- G4SDManager* pSDManager = G4SDManager::GetSDMpointer();
- if(hitsCollectionID == -1)
- 	hitsCollectionID = pSDManager -> GetCollectionID("HadrontherapyPhantomHitsCollection");
+/////////////////////////////////////////////////////////////////////////////
+void HadrontherapyEventAction::BeginOfEventAction(const G4Event* evt)
+{ 
+  G4int evtNb = evt->GetEventID();
+  
+  //printing survey
+  if (evtNb%printModulo == 0)
+    G4cout << "\n---> Begin of Event: " << evtNb << G4endl;
+   
+  G4SDManager* pSDManager = G4SDManager::GetSDMpointer();
+  if(hitsCollectionID == -1)
+    hitsCollectionID = pSDManager -> GetCollectionID("HadrontherapyDetectorHitsCollection");
 }
 
+/////////////////////////////////////////////////////////////////////////////
 void HadrontherapyEventAction::EndOfEventAction(const G4Event* evt)
 {  
   if(hitsCollectionID < 0)
-    return;
-
+  return;
   G4HCofThisEvent* HCE = evt -> GetHCofThisEvent();
-  HadrontherapyPhantomHitsCollection* CHC = NULL; 
  
   if(HCE)
-    CHC = (HadrontherapyPhantomHitsCollection*)(HCE -> GetHC(hitsCollectionID));
-  
-  if(CHC)
-    {
-      if(matrix)
-	{
-	  // Fill the matrix with the information: voxel and associated energy deposit 
-          // in the phantom at the end of the event
+  {
+    HadrontherapyDetectorHitsCollection* CHC = (HadrontherapyDetectorHitsCollection*)(HCE -> GetHC(hitsCollectionID));
+    if(CHC)
+     {
+	   matrix = HadrontherapyMatrix::getInstance();	 
+       if(matrix)
+	  { 
+	      // Fill the matrix with the information: voxel and associated energy deposit 
+          // in the detector at the end of the event
 
 	  G4int HitCount = CHC -> entries();
@@ -98,7 +98,7 @@
               matrix -> Fill(i, j, k, energyDeposit/MeV);              
 	    }
-	}
+	  }
     }
-
+  }
   // Extract the trajectories and draw them in the visualisation
 
Index: trunk/examples/advanced/hadrontherapy/src/HadrontherapyMatrix.cc
===================================================================
--- trunk/examples/advanced/hadrontherapy/src/HadrontherapyMatrix.cc	(revision 812)
+++ trunk/examples/advanced/hadrontherapy/src/HadrontherapyMatrix.cc	(revision 1230)
@@ -24,18 +24,6 @@
 // ********************************************************************
 //
-// $Id: HadrontherapyPhantomSD.cc; May 2005
-// ----------------------------------------------------------------------------
-//                 GEANT 4 - Hadrontherapy example
-// ----------------------------------------------------------------------------
-// Code developed by:
-//
-// G.A.P. Cirrone(a)*, F. Di Rosa(a), S. Guatelli(b), G. Russo(a)
-// 
-// (a) Laboratori Nazionali del Sud 
-//     of the National Institute for Nuclear Physics, Catania, Italy
-// (b) National Institute for Nuclear Physics Section of Genova, genova, Italy
-// 
-// * cirrone@lns.infn.it
-// ----------------------------------------------------------------------------
+// $Id: HadrontherapyMatrix.cc;
+// See more at: http://g4advancedexamples.lngs.infn.it/Examples/hadrontherapy//
 
 #include "HadrontherapyMatrix.hh"
@@ -44,31 +32,60 @@
 #include <fstream>
 
-HadrontherapyMatrix::HadrontherapyMatrix()
+HadrontherapyMatrix* HadrontherapyMatrix::instance = NULL;
+// Static method that only return a pointer to the matrix object
+HadrontherapyMatrix* HadrontherapyMatrix::getInstance() 
+{
+  return instance;
+}
+// This STATIC method delete (!) the old matrix and rewrite a new object returning a pointer to it
+HadrontherapyMatrix* HadrontherapyMatrix::getInstance(G4int voxelX, G4int voxelY, G4int voxelZ)  
+{
+    if (instance) delete instance;
+    instance = new HadrontherapyMatrix(voxelX, voxelY, voxelZ);
+    instance -> Initialize(); 	
+    return instance;
+}
+
+HadrontherapyMatrix::HadrontherapyMatrix(G4int voxelX, G4int voxelY, G4int voxelZ):
+    matrix(0)
 {  
-  // Number of the voxels of the phantom
-  numberVoxelX = 200;
-  numberVoxelY = 200;
-  numberVoxelZ = 200; 
- 
-  // Create the matrix
+// Number of the voxels of the phantom
+// For Y = Z = 1 the phantom is divided in slices (and not in voxels)
+// orthogonal to the beam axis
+  numberVoxelX = voxelX;
+  numberVoxelY = voxelY;
+  numberVoxelZ = voxelZ; 
+  // Create the dose matrix
   matrix = new G4double[numberVoxelX*numberVoxelY*numberVoxelZ];
+  if (matrix) G4cout << "Matrix: Memory space to store physical dose into " <<  
+                        numberVoxelX*numberVoxelY*numberVoxelZ <<
+		        " voxels has been allocated " << G4endl;
+  else G4Exception("Can't allocate memory to store physical dose!");
 }
 
 HadrontherapyMatrix::~HadrontherapyMatrix()
 {
-  delete[] matrix;
+    delete[] matrix;
+}
+
+void HadrontherapyMatrix::flush()
+{
+	if(matrix)
+	for(int i=0; i<numberVoxelX*numberVoxelY*numberVoxelZ; i++)
+	{
+	  matrix[i] = 0;
+	}
 }
 void HadrontherapyMatrix::Initialize()
 { 
-  // Initialise the elemnts of the matrix to zero
-
+// Initialise the elements of the matrix to zero
   for(G4int i = 0; i < numberVoxelX; i++)
     {
       for(G4int j = 0; j < numberVoxelY; j++)
-	{
-	  for(G4int k = 0; k < numberVoxelZ; k++)
+	   {
+	      for(G4int k = 0; k < numberVoxelZ; k++)
 
-	    matrix[(i*numberVoxelY+j)*numberVoxelZ+k] = 0.;
-	}
+	      matrix[Index(i,j,k)] = 0.;
+	   } 
     }
 }
@@ -78,8 +95,8 @@
 {
   if (matrix)
-    matrix[(i*numberVoxelY+j)*numberVoxelZ+k] += energyDeposit;
+    matrix[Index(i,j,k)] += energyDeposit;
   
-  // Store the energy deposit in the matrix elemnt corresponding 
-  // to the phantom voxel  
+  // Store the energy deposit in the matrix element corresponding 
+  // to the phantom voxel  i, j, k
 }
 
@@ -95,11 +112,14 @@
   if (matrix)
     {  
-	for(G4int l = 0; l < numberVoxelZ; l++) 
-	  {
-	    k = l;
-	    
-	    for(G4int m = 0; m < numberVoxelY; m++) 
-	      { 
-		j = m * numberVoxelZ + k; 
+      std::ofstream ofs;    	
+      ofs.open("DoseDistribution.out"); 
+      
+      for(G4int l = 0; l < numberVoxelZ; l++) 
+	{
+	  k = l;
+	  
+	  for(G4int m = 0; m < numberVoxelY; m++) 
+	    { 
+	      j = m * numberVoxelZ + k; 
 		
 		for(G4int n = 0; n <  numberVoxelX; n++)
@@ -108,13 +128,15 @@
 		    if(matrix[i] != 0)
 		      {	
-					
-#ifdef G4ANALYSIS_USE 	
+			ofs << n << '\t' << m << '\t' <<
+			  k << '\t' << matrix[i] << G4endl;
+		       	
+#ifdef ANALYSIS_USE
 			HadrontherapyAnalysisManager* analysis = 
-			  HadrontherapyAnalysisManager::getInstance();
+			HadrontherapyAnalysisManager::getInstance();
 			analysis -> FillEnergyDeposit(n, m, k, matrix[i]);
 			analysis -> BraggPeak(n, matrix[i]);
 #endif
 		      }
-		  }       
+}       
 	      }
 	  }
Index: trunk/examples/advanced/hadrontherapy/src/HadrontherapyModulator.cc
===================================================================
--- trunk/examples/advanced/hadrontherapy/src/HadrontherapyModulator.cc	(revision 812)
+++ trunk/examples/advanced/hadrontherapy/src/HadrontherapyModulator.cc	(revision 1230)
@@ -24,18 +24,6 @@
 // ********************************************************************
 //
-// $Id: HadrontherapyModulator.cc; May 2005
-// ----------------------------------------------------------------------------
-//                 GEANT 4 - Hadrontherapy example
-// ----------------------------------------------------------------------------
-// Code developed by:
-//
-// G.A.P. Cirrone(a)*, F. Di Rosa(a), S. Guatelli(b), G. Russo(a)
-// 
-// (a) Laboratori Nazionali del Sud 
-//     of the National Institute for Nuclear Physics, Catania, Italy
-// (b) National Institute for Nuclear Physics Section of Genova, genova, Italy
-// 
-// * cirrone@lns.infn.it
-// ----------------------------------------------------------------------------
+// $Id: HadrontherapyModulator.cc; 
+// See more at: http://g4advancedexamples.lngs.infn.it/Examples/hadrontherapy
 
 #include "G4Material.hh"
@@ -51,11 +39,10 @@
 #include "G4VisAttributes.hh"
 #include "G4Colour.hh"
-#include "HadrontherapyMaterial.hh"
 #include "HadrontherapyModulator.hh"
-#include "HadrontherapyMaterial.hh"
 #include "G4Transform3D.hh"
 #include "G4ios.hh"
 #include <fstream>
 #include "G4RunManager.hh"
+#include "G4NistManager.hh"
 
 HadrontherapyModulator::HadrontherapyModulator():physiMotherMod(0),
@@ -141,21 +128,18 @@
   rm -> rotateY(phi); 
 }
-
+/////////////////////////////////////////////////////////////////////////////
 HadrontherapyModulator::~HadrontherapyModulator() 
 {
   delete rm;
 }
-
+/////////////////////////////////////////////////////////////////////////////
 void HadrontherapyModulator::BuildModulator(G4VPhysicalVolume* motherVolume)
 {
-
-
-  //Materials used for the modulator wheel
-  HadrontherapyMaterial* material = new HadrontherapyMaterial();
-
-  G4Material* Mod0Mater = material -> GetMat("Air");
-  G4Material* ModMater = material -> GetMat("Air");
-  delete material;
-
+  G4bool isotopes = false;
+  G4Material* airNist =  G4NistManager::Instance()->FindOrBuildMaterial("G4_AIR", isotopes);
+
+  G4Material* Mod0Mater = airNist;
+  G4Material* ModMater = airNist;
+ 
   G4double innerRadiusOfTheTube = 2.5 *cm;
   G4double outerRadiusOfTheTube = 9.5 *cm;
@@ -163,12 +147,9 @@
 
   // Mother of the modulator wheel  
-
-  G4ThreeVector positionMotherMod = G4ThreeVector(-2260.50 *mm, 30 *mm, 50 *mm);
+  G4ThreeVector positionMotherMod = G4ThreeVector(-1960.50 *mm, 30 *mm, 50 *mm);
  
   G4Box* solidMotherMod = new G4Box("MotherMod", 12 *cm, 12 *cm, 12 *cm);
  
   G4LogicalVolume * logicMotherMod = new G4LogicalVolume(solidMotherMod, Mod0Mater,"MotherMod",0,0,0);
-
- 
 
   physiMotherMod = new G4PVPlacement(rm,positionMotherMod,  "MotherMod", 
@@ -200,5 +181,4 @@
   logicMod0 = new G4LogicalVolume(solidMod0, Mod0Mater, "Mod0",0,0,0);
   
-  
   physiMod0 = new G4PVPlacement(G4Transform3D(rm2, positionMod0), 
 				logicMod0,    
@@ -212,5 +192,4 @@
   // First modulator sclice
   //----------------------------------------------------------
- 
  
   G4double startAngleOfTheTube1 = 54.267*deg;
Index: trunk/examples/advanced/hadrontherapy/src/HadrontherapyParticles.cc
===================================================================
--- trunk/examples/advanced/hadrontherapy/src/HadrontherapyParticles.cc	(revision 812)
+++ trunk/examples/advanced/hadrontherapy/src/HadrontherapyParticles.cc	(revision 1230)
@@ -24,18 +24,7 @@
 // ********************************************************************
 //
-// $Id: HadrontherapyParticles.cc; May 2005
-// ----------------------------------------------------------------------------
-//                 GEANT 4 - Hadrontherapy example
-// ----------------------------------------------------------------------------
-// Code developed by:
-//
-// G.A.P. Cirrone(a)*, F. Di Rosa(a), S. Guatelli(b), G. Russo(a)
-// 
-// (a) Laboratori Nazionali del Sud 
-//     of the National Institute for Nuclear Physics, Catania, Italy
-// (b) National Institute for Nuclear Physics Section of Genova, genova, Italy
-// 
-// * cirrone@lns.infn.it
-// ----------------------------------------------------------------------------
+// $Id: HadrontherapyParticles.cc; 
+// See more at: http://g4advancedexamples.lngs.infn.it/Examples/hadrontherapy
+
 #include "HadrontherapyParticles.hh"
 #include "G4ParticleDefinition.hh"
